#include "compass.h"
#include <qpainter.h>
#include <math.h>
compass::compass(QWidget* parent,const char* name):QFrame(parent,name)
{
  dgr=0;
}



compass:: ~compass()
{

} 

void compass::set(int degrees)
{
  dgr=degrees;
}

void compass::drawContents( QPainter *p )
{
  #define delta 16
  QRect c;
  int R;
  c=contentsRect();
  c.moveTopLeft(QPoint(delta,delta));
  c.setHeight(c.height()-2*delta);
  c.setWidth(c.width()-2*delta);
  R=c.width()/2;
  QPen pn=p->pen();
  p->drawText(c.left()+(c.width()/2)-3,c.top()-4,"N"); 
  p->drawText(c.left()+(c.width()/2)-3,c.bottom()+12,"S");
  p->drawText(c.left()-10,c.top()+c.height()/2+6,"W"); 
  p->drawText(c.right()+6,c.top()+c.height()/2+6,"E");
 
   pn.setWidth(4);
   pn.setColor(foregroundColor());
   p->setPen(pn);
   
   QPoint pt(sin((dgr*2*M_PI)/360)*R+c.center().x(),c.center().y()-cos((dgr*2*M_PI)/360)*R);
   QPoint pt2(pt.x()-20*sin(((dgr-12)*2*M_PI)/360),pt.y()+20*cos(((dgr-12)*2*M_PI)/360));
   QPoint pt3(pt.x()-20*sin(((dgr+12)*2*M_PI)/360),pt.y()+20*cos(((dgr+12)*2*M_PI)/360));
   p->setBrush(red);    p->drawEllipse(c);    p->drawLine(c.center(),pt);
   p->drawLine(pt2,pt);
   p->drawLine(pt3,pt);
   pn.setWidth(1);
   p->setPen(pn);

   p->drawLine(c.left()+c.width()/2-1,c.top(), c.left()+c.width()/2-1,c.bottom());

   p->drawLine(c.left(),c.top()+c.height()/2-1, c.right(),c.top()+c.height()/2-1);

}


